 member

 include('xlsxwriter.inc')

 MAP

     MODULE('libxlsxwriter.dll')
       workbook_new(*CSTRING Filename),LONG,RAW,C,NAME('new_workbook')
       workbook_add_worksheet(LONG workbook,*CSTRING sheetname),LONG,RAW,C,NAME('workbook_add_worksheet')
       workbook_add_format(LONG workbook),LONG,RAW,C,NAME('workbook_add_format')
       workbook_close(LONG workbook),LONG,RAW,C,NAME('workbook_close')

       worksheet_write_number(LONG worksheet,LONG row,LONG col,REAL number,LONG format),LONG,RAW,C,NAME('worksheet_write_number')
       worksheet_write_string(LONG worksheet,LONG row,LONG col,*CSTRING string,LONG format),LONG,RAW,C,NAME('worksheet_write_string')
       worksheet_write_datetime(LONG worksheet,LONG row,LONG col,*DATETIME datetime,LONG format),LONG,RAW,C,NAME('worksheet_write_datetime')
       worksheet_write_blank(LONG worksheet,LONG row,LONG col,LONG format),LONG,RAW,C,NAME('worksheet_write_blank')
       worksheet_set_row(LONG worksheet,LONG row,REAL height,LONG format),LONG,RAW,C,NAME('worksheet_set_row')
       worksheet_set_column (LONG worksheet,LONG first_col,LONG last_col,REAL width,LONG format),LONG,RAW,C,NAME('worksheet_set_column')
       worksheet_merge_range(LONG worksheet,LONG first_row,LONG first_col,LONG last_row,LONG last_col,*CSTRING string,LONG format),LONG,RAW,C,NAME('worksheet_merge_range')
!               worksheet_freeze_panes(LONG worksheet,LONG row,LONG col),RAW,C,NAME('worksheet_freeze_panes')
!               worksheet_hide_zero(LONG worksheet),RAW,C,NAME('worksheet_hide_zero')

       format_set_font_name(LONG format,*CSTRING font_name),RAW,C,NAME('format_set_font_name')
       format_set_font_color(LONG format,LONG color),RAW,C,NAME('format_set_font_color')
       format_set_bold(LONG format),RAW,C,NAME('format_set_bold')
       format_set_italic(LONG format),RAW,C,NAME('format_set_italic')
       format_set_underline(LONG format,BYTE style),RAW,C,NAME('format_set_underline')
       format_set_strikeout(LONG format),RAW,C,NAME('format_set_strikeout')
       format_set_font_script(LONG format,BYTE style),RAW,C,NAME('format_set_font_script')
       format_set_num_format(LONG format,*CSTRING num_format),RAW,C,NAME('format_set_num_format')
       format_set_num_format_index(LONG format,BYTE index),RAW,C,NAME('format_set_num_format_index')
       format_set_align (LONG format,BYTE alignment),RAW,C,NAME('format_set_align')
       format_set_text_wrap(LONG format),RAW,C,NAME('format_set_text_wrap')
       format_set_rotation(LONG format,SHORT angle),RAW,C,NAME('format_set_rotation')
       format_set_indent(LONG format,BYTE level),RAW,C,NAME('format_set_indent')
       format_set_shrink(LONG format),RAW,C,NAME('format_set_shrink')
       format_set_pattern(LONG format,BYTE index),RAW,C,NAME('format_set_pattern')
       format_set_bg_color(LONG format,LONG color),RAW,C,NAME('format_set_bg_color')
       format_set_fg_color(LONG format,LONG color),RAW,C,NAME('format_set_fg_color')
       format_set_border(LONG format,BYTE style),RAW,C,NAME('format_set_border')
       format_set_bottom(LONG format,BYTE style),RAW,C,NAME('format_set_bottom')
       format_set_top(LONG format,BYTE style),RAW,C,NAME('format_set_top')
       format_set_left(LONG format,BYTE style),RAW,C,NAME('format_set_left')
       format_set_right(LONG format,BYTE style),RAW,C,NAME('format_set_right')
       format_set_border_color(LONG format,LONG color),RAW,C,NAME('format_set_border_color')
       format_set_bottom_color(LONG format,LONG color),RAW,C,NAME('format_set_bottom_color')
       format_set_top_color(LONG format,LONG color),RAW,C,NAME('format_set_top_color')
       format_set_left_color(LONG format,LONG color),RAW,C,NAME('format_set_left_color')
       format_set_right_color(LONG format,LONG color),RAW,C,NAME('format_set_right_color')

     END

    MODULE('WIN API')
      winapi::MultiByteToWideChar(long CodePage, long dwFlags, long lpMultiByteStr, long cbMultiByte, long lpWideCharStr, long cchWideCharStr),long,pascal,name('MultiByteToWideChar')
      winapi::WideCharToMultiByte(long CodePage, long dwFlags, long lpWideCharStr, long cchWideChar, long lpMultiByteStr, long cbMultiByte, long lpDefaultChar, long lpUsedDefaultChar),long,pascal,name('WideCharToMultiByte')
      winapi::ShellExecute(LONG phWnd, <*CSTRING pAction>, *CSTRING pFilename, <*CSTRING pParameters>, <*CSTRING pDirectory>, LONG pFlags=1), LONG, PASCAL, RAW, PROC, NAME('ShellExecuteA')
    END

 END


xlsxwriter.NewWorkbook       PROCEDURE(STRING Filename_)
  CODE
    SELF.Filename=clip(Filename_)
    SELF.Workbook=workbook_new(SELF.Filename)

xlsxwriter.AddWorksheet      PROCEDURE(STRING Sheetname_)
l           long
strInpChar  &CSTRING
strWideChar &CSTRING
strOutChar  &CSTRING
lenWideChar long
  CODE
    l = len(clip(Sheetname_))
    strInpChar &= new(CSTRING(l + 1)); strInpChar = all('<0>',l)
    strWideChar &= new(CSTRING(l*2 + 1)); strWideChar = all('<0>',l*2)
    strOutChar &= new(CSTRING(l*2 + 1)); strOutChar = all('<0>',l*2)
    strInpChar = clip(Sheetname_)
    lenWideChar = winapi::MultiByteToWideChar(1251,0,address(strInpChar),l,address(strWideChar),l*2)
    res# = winapi::WideCharToMultiByte(65001,0,address(strWideChar),lenWideChar,address(strOutChar),l*2,0,0)
    SELF.ActiveWorksheet=workbook_add_worksheet(SELF.Workbook,strOutChar)
    strInpChar = all('<0>',l); dispose(strInpChar)
    strWideChar = all('<0>',l*2); dispose(strWideChar)
    strOutChar = all('<0>',l*2); dispose(strOutChar)
    return SELF.ActiveWorksheet

xlsxwriter.AddFormat         PROCEDURE()
  CODE
    return 0

xlsxwriter.CloseWorkbook     PROCEDURE()
  CODE
    return workbook_close(SELF.Workbook)

xlsxwriter.WriteNumber     PROCEDURE(LONG row_,LONG col_,REAL number_,<LONG format_>)
  CODE
    if omitted(5)
      return worksheet_write_number(SELF.ActiveWorksheet,row_-1,col_-1,number_,0)
    else
      return worksheet_write_number(SELF.ActiveWorksheet,row_-1,col_-1,number_,format_)
    end

xlsxwriter.WriteString     PROCEDURE(LONG row_,LONG col_,STRING string_,<LONG format_>)
l           long
strInpChar  &CSTRING
strWideChar &CSTRING
strOutChar  &CSTRING
lenWideChar long
 code

    l = len(clip(string_))

    strInpChar &= new(CSTRING(l + 1)); strInpChar = all('<0>',l)
    strWideChar &= new(CSTRING(l*2 + 1)); strWideChar = all('<0>',l*2)
    strOutChar &= new(CSTRING(l*2 + 1)); strOutChar = all('<0>',l*2)

    strInpChar = clip(string_)
    lenWideChar = winapi::MultiByteToWideChar(1251,0,address(strInpChar),l,address(strWideChar),l*2)
    res# = winapi::WideCharToMultiByte(65001,0,address(strWideChar),lenWideChar,address(strOutChar),l*2,0,0)
    if omitted(5)
      return worksheet_write_string(SELF.ActiveWorksheet,row_-1,col_-1,strOutChar,0)
    else
      return worksheet_write_string(SELF.ActiveWorksheet,row_-1,col_-1,strOutChar,format_)
    end
    strInpChar = all('<0>',l); dispose(strInpChar)
    strWideChar = all('<0>',l*2); dispose(strWideChar)
    strOutChar = all('<0>',l*2); dispose(strOutChar)

xlsxwriter.WriteBlank     PROCEDURE(LONG row_,LONG col_,<LONG format_>)
str CSTRING(256)
  CODE
    if omitted(4)
      return worksheet_write_blank(SELF.ActiveWorksheet,row_-1,col_-1,0)
    else
      return worksheet_write_blank(SELF.ActiveWorksheet,row_-1,col_-1,format_)
    end

xlsxwriter.WriteDateTime     PROCEDURE(LONG row_,LONG col_,LONG date_,LONG time_,<LONG format_>)
dt      GROUP(DATETIME)
 END
  CODE
    dt.year=year(date_)
    dt.month=month(date_)
    dt.day=day(date_)
    dt.hour=int((time_-1)/360000)
    dt.min=int((time_-1-dt.hour*360000)/6000)
    dt.sec=int((time_-1-dt.hour*360000-dt.min*6000)/100)
    if omitted(5)
      return worksheet_write_datetime(SELF.ActiveWorksheet,row_-1,col_-1,dt,0)
    else
      return worksheet_write_datetime(SELF.ActiveWorksheet,row_-1,col_-1,dt,format_)
    end
